.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\ole32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\Comctl32.inc
include \masm32\include\masm32.inc


includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\Comctl32.lib
includelib \masm32\lib\masm32.lib


include \masm32\macros\macros.asm

WinMain proto :HINSTANCE,:HINSTANCE,:LPSTR,:DWORD
StaticMain proto :DWORD

.data
AppName     db "Transparent with opaque Static",0
ClassName   db "just_parent_window",0

.data?
hInstance    HINSTANCE ?
hMain        dd ?

.code

start:
invoke  GetModuleHandle,NULL
mov  hInstance,eax
invoke   WinMain,eax,0,0,SW_SHOWDEFAULT 
invoke   ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

local wc:WNDCLASSEX ; create local variables on stack
local msg:MSG
local hwnd:HWND

   mov   wc.cbSize,sizeof WNDCLASSEX ; fill values in members of wc
   mov   wc.style,CS_DBLCLKS
   mov   wc.lpfnWndProc,offset WndProc
   mov   wc.cbClsExtra,NULL
   mov   wc.cbWndExtra,NULL 
   m2m   wc.hInstance,hInst
   mov   wc.hbrBackground,COLOR_BTNFACE+6 
   mov   wc.lpszMenuName,NULL
   mov   wc.lpszClassName,offset ClassName
   invoke LoadIcon,NULL,IDI_APPLICATION
   mov   wc.hIcon,eax
   mov   wc.hIconSm,eax
   invoke  LoadCursor,0,IDC_ARROW
   mov   wc.hCursor,eax
   invoke   RegisterClassEx,addr wc ; register our window class
   
  ; Create the window  
   invoke   CreateWindowEx,NULL ,\ 
   offset ClassName,offset AppName,WS_OVERLAPPEDWINDOW ,\
   100,100,300,225,NULL,NULL,hInstance,NULL
   mov   hwnd,eax
   
   invoke   ShowWindow,hwnd,SW_SHOWNORMAL ; display our window
   invoke   UpdateWindow,hwnd

   .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
   .endw
   mov eax,msg.wParam
   ret
WinMain endp
WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
   Local ps:PAINTSTRUCT
   Local hdc:HDC
   Local mdc:HDC
   Local xRc:RECT

   .if uMsg==WM_DESTROY
    invoke PostQuitMessage,0
   .elseif uMsg==WM_CREATE
    invoke   GetWindowLong,hWnd,GWL_EXSTYLE
    or   eax,WS_EX_LAYERED or WS_EX_NOACTIVATE
    invoke   SetWindowLong,hWnd,GWL_EXSTYLE,eax
    invoke   SetLayeredWindowAttributes,hWnd,00FF00FFh,220,LMA_ALPHA or LMA_COLORKEY
    m2m   hMain,hWnd
    invoke   CreateThread, 0, 0, offset StaticMain, hInstance, 1, 0

   .else
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam      
    ret
   .endif
   xor eax,eax
   ret
WndProc endp
StaticMain proc uses esi hInst:dword
   LOCAL wc:WNDCLASSEX
   LOCAL msg:MSG
   LOCAL hwnd:HWND

   mov   wc.cbSize,sizeof WNDCLASSEX
   mov   wc.style,CS_NOCLOSE
   mov   wc.lpfnWndProc,offset StaticWndProc
   mov   wc.cbClsExtra,NULL
   mov   wc.cbWndExtra,NULL
   m2m   wc.hInstance,hInst
   mov   wc.hbrBackground,COLOR_BTNFACE+1  ;COLOR_WINDOW+4
   mov   wc.lpszMenuName,NULL
   mov   wc.lpszClassName,CTXT("StaticClassName")
   invoke   LoadIcon,hInst,IDI_APPLICATION
   mov   wc.hIcon,eax
   mov   wc.hIconSm,eax
   invoke   LoadCursor,NULL,IDC_ARROW
   mov   wc.hCursor,eax
   invoke   RegisterClassEx,addr wc
   
   invoke   CreateWindowEx,NULL,CTXT("StaticClassName"),CTXT("StaticName"),\
   WS_CHILD or  WS_VISIBLE or WS_POPUP ,90,50,160,140,NULL,NULL,hInst,NULL
   mov   hwnd,eax

   invoke   ShowWindow,hwnd,SW_SHOWNORMAL
   invoke   UpdateWindow,hwnd
   .while   TRUE
    invoke   GetMessage,addr msg,0,0,0
    .break   .if (!eax)
    invoke   TranslateMessage,addr msg
    invoke   DispatchMessage,addr msg
   .endw
   mov eax,msg.wParam
   ret

StaticMain endp  
StaticWndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

Local ps:PAINTSTRUCT
Local hdc:HDC
Local mdc:HDC
Local xRc:RECT

   .if uMsg==WM_CREATE
      invoke   GetWindowLong,hWnd,GWL_EXSTYLE
      or   eax,WS_EX_LAYERED or WS_EX_NOACTIVATE
      invoke   SetWindowLong,hWnd,GWL_EXSTYLE,eax
      invoke   SetLayeredWindowAttributes,hWnd,00FF00FFh,255,LMA_ALPHA or LMA_COLORKEY
      
    ;  invoke   InvalidateRect,hWnd,0,TRUE
    ;  invoke   UpdateWindow,hWnd
    ;  invoke   SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE

   .elseif uMsg == WM_DESTROY
      invoke   PostQuitMessage,NULL
  ; .elseif uMsg==   WM_NCHITTEST
   ;   invoke   DefWindowProc,hWnd,uMsg,wParam,lParam
    ;  .if eax==HTCLIENT
   ;      mov   eax,HTCAPTION
    ;  .endif
   ;   ret
   .else
      invoke   DefWindowProc,hWnd,uMsg,wParam,lParam
      ret
   .endif
   xor eax,eax
   ret
StaticWndProc endp
end start